Index: doc/CHANGES
===================================================================
--- doc/CHANGES	(revision 210d1d9cf4366d9933c02383300175e4b573be61)
+++ doc/CHANGES	(revision b7d3cc34f68dab7b8f7d0777711317b334fc2219)
@@ -799,5 +5,5 @@
   some situations.
 - Outgoing MSN typing notifications are now understood correctly by the
-  original MS Mac/Windows clients (again).
+  orignal MS Mac/Windows clients (again).
 - Added "account add $protocol" to the documentation, got rid of a lot
   of over-markup (i.e. overuse of bold-tags), reviewed some other parts.
Index: doc/CREDITS
===================================================================
--- doc/CREDITS	(revision 210d1d9cf4366d9933c02383300175e4b573be61)
+++ doc/CREDITS	(revision b7d3cc34f68dab7b8f7d0777711317b334fc2219)
@@ -50,10 +50,7 @@
 - Frank Thieme, for the info-command enhancements and other patches.
 - Marcus Dennis, for some bitlbeed enhancements.
-- infamous41md, for security auditing BitlBee code.
+- 1nfamus, for security auditing BitlBee code.
 - Tijmen Ruizendaal, for some useful BitlBee-related irssi scripts.
 - Ed Schouten, for reporting bugs.
-- Greg (gropeep.org), for updating the Yahoo! module to fix some issues
-  that were there for quite some time already.
-- misc@mandriva.org for lots of Jabber contributions.
 
 - And all other users who help us by sending useful bug reports, positive
Index: doc/FAQ
===================================================================
--- doc/FAQ	(revision 210d1d9cf4366d9933c02383300175e4b573be61)
+++ doc/FAQ	(revision b7d3cc34f68dab7b8f7d0777711317b334fc2219)
@@ -12,5 +12,5 @@
    WTH does BitlBee mean then?
 A: There are a few explanations. But the most symbolical goes like: the two
-   colors of the bee symbolize the two worlds between which the Bee flies. On
+   colors of the bee symbolize the two worlds betwee which the Bee flies. On
    the one hand there's the IM-networks, on the other is IRC.
    
@@ -38,7 +38,37 @@
    artistic creativity.
 
+Q: Why is there no mailing list/CVS/<insert your favourite development tool
+   here>?
+A: Short answer: we don't need it.
+   
+   Longer answer: and we're not completely convinced of their merits.
+   
+   Long answer: we currently use some shell scripts which make sure all
+   developers' copies are in sync with Wilmer's master copy. These shell
+   scripts also produce development "releases" and packages, as well as
+   stick them on a http-server. Patches are sent to Wilmer who decides
+   whether or not a patch should be applied and if it may need some
+   additional changes. This has the consistency advantage of a one-person
+   project while having the capacity of more people available. The system
+   works and we are kind of attached to it.
+   
 Q: When is $random_feature going to be implemented?
-A: It depends on the feature. We keep a list of all wishlist "bugs" in our
-   Bug Tracking system at https://bugs.bitlbee.org/
+A: Please do consult doc/TODO (preferably in a development snapshot, which
+   is more up-to-date than a TODO in a release version) before asking.
+   Please also check the documentation. You'd not be the first one to request
+   a feature which already exists!
+   
+   If your fabulous feature seems not to be requested before, just join
+   #bitlbee on irc.oftc.net and tell us the news.
+   
+   If your feature request is already in the TODO list, of course you can
+   still request it again/make us know that you'd like to see the feature as
+   well. But when the feature is in the "post-1.0" list, it's probably not
+   going to help. Most of the features in this list are low-priority because
+   we (the developers) don't need (or even want) them. (File transfers are a
+   good example here.)
+   Hence, they'll only be implemented when we really got too much spare
+   time. Obviously, if you're willing to help (i.e. submit a patch), you're
+   always welcome.
 
 Q: The messages I send and/or receive look weird. I see weird characters and
@@ -46,9 +76,6 @@
    non-ASCII characters!
 A: You probably have to change some settings. To get rid of HTML in messages,
-   see "help set strip_html". If you seem to have problems with your charset,
-   see "help set charset".
-   
-   Although actually most of these problems should be gone by now. So if you
-   can't get things to work well, you might have found a bug.
+   see "help set html". If you seem to have problems with your charset, see
+   "help set charset".
 
 Q: Is BitlBee forked from Gaim?
@@ -62,10 +89,15 @@
    These days, we replaced the Yahoo! code with libyahoo2 (which is a
    separate Yahoo! module. It's derived from Gaim, but separately
-   maintained) and wrote our own MSN, Jabber and Twitter modules from
-   scratch. Most of the API has also been changed, so by now the only traces
-   of Gaim left are in the "nogaim" filename.
+   maintained) and wrote our own MSN module. More modules are probably going
+   to be changed, so in the near future, the API might be the only thing
+   left from Gaim.
+
+Q: What's that Gaim doing in BitlBee error messages and my Jabber resource?
+A: Ah, well, as you probably know we use some of Gaim's IM-modules, and we
+   don't think it's worth our time to do a search-and-replace over the whole
+   source to get rid of every reference to Gaim. In fact, we don't want to,
+   since we don't want to pretend we wrote all that code.
    
-   There is good news for Gaim (or now Pidgin, of course) fans though:
-   BitlBee can now be compiled to use libpurple for all IM interactions.
-   This makes BitlBee a bit more resource-hungry, but adds support for many
-   IM protocols/networks that couldn't be used from BitlBee so far.
+   About Jabber: If you want a different resource string, you can set it
+   when logging in by appending it to your Jabber ID, like:
+   lintux@jabber.com/BitlBee
Index: doc/Makefile
===================================================================
--- doc/Makefile	(revision 210d1d9cf4366d9933c02383300175e4b573be61)
+++ doc/Makefile	(revision b7d3cc34f68dab7b8f7d0777711317b334fc2219)
@@ -1,20 +1,14 @@
 -include ../Makefile.settings
-ifdef _SRCDIR_
-_SRCDIR_ := $(_SRCDIR_)doc/
-endif
-
-all:
-	$(MAKE) -C user-guide
 
 install:
 	mkdir -p $(DESTDIR)$(MANDIR)/man8/ $(DESTDIR)$(MANDIR)/man5/
-	$(INSTALL) -m 0644 $(_SRCDIR_)bitlbee.8 $(DESTDIR)$(MANDIR)/man8/
-	$(INSTALL) -m 0644 $(_SRCDIR_)bitlbee.conf.5 $(DESTDIR)$(MANDIR)/man5/
-	$(MAKE) -C user-guide $@
+	install -m 0644 bitlbee.8 $(DESTDIR)$(MANDIR)/man8/
+	install -m 0644 bitlbee.conf.5 $(DESTDIR)$(MANDIR)/man5/
+	make -C user-guide $@
 
 uninstall:
 	rm -f $(DESTDIR)$(MANDIR)/man8/bitlbee.8*
 	rm -f $(DESTDIR)$(MANDIR)/man5/bitlbee.conf.5*
-	$(MAKE) -C user-guide $@
+	make -C user-guide $@
 
 .PHONY: install uninstall
Index: doc/README
===================================================================
--- doc/README	(revision 210d1d9cf4366d9933c02383300175e4b573be61)
+++ doc/README	(revision b7d3cc34f68dab7b8f7d0777711317b334fc2219)
@@ -9,27 +9,4 @@
 make install will move all the files to the right places.
 
-RUN MODES
-=========
-
---- (Fork)Daemon mode
-
-These days ForkDaemon mode is the recommended way of running BitlBee. The
-difference between Daemon and ForkDaemon mode is that in the latter, a
-separate process is spawned for every user. This costs a little bit more
-memory, but means that if one user hits a bug in the code, not all other
-users get disconnected with him/her.
-
-To use BitlBee in any daemon mode, just start it with the right flags or
-enable it in bitlbee.conf (see the RunMode option). You probably want to
-write an init script to start BitlBee automatically after a reboot. (This
-is where you realise using a package from your distro would've been a better
-idea. :-P)
-
-Please do make sure that the user BitlBee runs as (not root, please!) is
-able to read from and write to the /var/lib/bitlbee directory to save your
-settings!
-
---- inetd installation (more or less deprecated)
-
 After installation you have to set up inetd (you got that one running,
 right? If not, just take a look at utils/bitlbeed.c) to start BitlBee. You
@@ -41,25 +18,9 @@
 of just 'nobody') might be a good idea.
 
-*BSD/Darwin/OSX NOTE: Most *BSD inetds are more strict than the one that
-comes with Linux systems. Possibly all non-Linux inetds are like this. They
-don't allow you to specify a port number in the inetd.conf entry, instead
-you have to put a service name there (one that is also mentioned in
-/etc/services). So if there's no line in /services for 6667/tcp (or whatever
-you choose), add it and use that name in the inetd.conf entry.
-
--- xinetd installation (equally deprecated)
-
-Most machines use xinetd instead of inetd these days. If your machine runs
-xinetd, you can copy the bitlbee.xinetd file from the doc/ directory to your
-xinetd.d/ directory. Most likely you'll have to change a thing or two before
-it'll work.
-
-After configuring your (x)inetd, send the daemon a SIGHUP and things should
-work. If not, see your syslogs, since both daemons will complain there when
-something's wrong.
-
 Also, don't forget to create the configuration directory (/var/lib/bitlbee/
 by default) and chown it to the UID BitlBee is running as. Make sure this
 directory is read-/writable by this user only.
+
+(For xinetd users a xinetd configuration file is included: doc/bitlbee.xinetd)
 
 
@@ -68,17 +29,12 @@
 
 BitlBee's only real dependency is GLib. This is available on virtually every
-platform. Any recent version of GLib (2.4 or higher) will work.
+platform. Any recent version of GLib (including 1.x versions) will work.
 
-Off-the-Record encryption support can be included if libotr is available on
-your machine. Pass --otr=1 to configure to build it into BitlBee, or
---otr=plugin to build it as a separate loadable plugin (mostly meant for
-distro packages).
-
-These days, many IM protocols use SSL/TLS connections (for authentication
-or for the whole session). BitlBee can use several SSL libraries for this:
-GnuTLS, NSS (which comes with Mozilla) and OpenSSL. OpenSSL is not GPL-
-compatible in some situations, so using GnuTLS is preferred. However,
-especially on *BSD, OpenSSL can be considered part of the operating system,
-which eliminates the GPL incompatibility.
+These days, MSN Messenger clients have to connect to the MS Passport servers
+through HTTPS. BitlBee can use serveral SSL libraries for this: GnuTLS, NSS
+(which comes with Mozilla) and OpenSSL. OpenSSL is not GPL-compatible in some
+situations, so using GnuTLS or NSS is preferred. However, especially on *BSD,
+OpenSSL can be considered part of the operating system, which eliminates the
+GPL incompatibility.
 
 The incompatibility is also the reason why the SSL library detection code
@@ -92,12 +48,51 @@
 ==================
 
-The configure script is may not work very well with some non-bash shells (but
-dash is supported), so if you experience problems, make sure you use bash to
-run the script. Same for the Makefile, it only works well with GNU make. (gmake
-on most BSD systems)
+FreeBSD NOTE: It looks like FreeBSD does allow port numbers instead of service
+names in inetd.conf, as long as the service for this port exists in
+/etc/services. Linux isn't this strict. If you got problems in FreeBSD, just
+add a line for your chosen port number to /etc/services.
 
-If someone can tell us how to write Makefiles that work with both/all
-versions of make, we'd love to hear it, but it seems this just isn't
-possible.
+Darwin/Mac OS X is even more strict; you should add a bitlbee service to
+/etc/services and use that name in inetd.conf. Not really a problem, since
+that's the cleanest way of doing this on any operating system anyway.
+
+Cygwin NOTE: You'll need a glib installation to run BitlBee. However, Cygwin
+doesn't provide a glib package. You can download a binary tar.gz from:
+<http://my.dreamwiz.com/jbdoll/>. When you installed it, BitlBee should work
+fine. You'll probably like bitlbeed or xinetd to get it running on the
+network.
+
+On some non-Linux systems the program still suffers from some random bugs.
+Please do report them, we might be able to fix them if they're not too
+mysterious.
+
+
+RUNNING ON SERVERS WITH MANY USERS
+==================================
+
+BitlBee is not yet bug-free. Sometimes a bug causes the program to get into
+an infinite loop. Something you really don't want on a public server,
+especially when that machine is also used for other (mission-critical) things.
+For now we can't do much about it. We haven't seen that happen for a long
+time already on our own machines, but some people still manage to get
+themselves in nasty situations we haven't seen before.
+
+For now the best we can offer against this problem is bitlbeed, which allows
+you to setrlimit() the child processes to use no more than a specified
+number of CPU seconds. Not the best solution (not really a solution anyway),
+but certainly trashing one busy daemon process is better than trashing your
+whole machine.
+
+We don't believe adding a limit for bitlbee to /etc/security/limits.conf will
+work, because that file is only read by PAM (ie just for real login users,
+not daemons).
+
+See utils/bitlbeed.c for more information about the program.
+
+Just a little note: We run our public server im.bitlbee.org for a couple of
+months now, and so far we haven't experienced this problem yet. The only
+BitlBee processes killed because of CPU-time overuse were running for a long
+time already, they were usually killed during the MSN login process (which
+is quite CPU-time consuming).
 
 
@@ -126,8 +121,4 @@
 on it almost immediately. And the result is BitlBee.
 
-In the years after, Gaim was renamed to Pidgin, BitlBee got libpurple support
-allowing to use Pidgin plugins and the support for the old chatprotocols ICQ,
-MSN and AIM was finally removed from BitlBee.
-
 
 WEBSITE
@@ -135,27 +126,22 @@
 
 You can find new releases of BitlBee at:
-https://www.bitlbee.org/
-
-The bug tracking system:
-https://bugs.bitlbee.org/
-
-Our version control system is Git. Our repository is at:
-https://github.com/bitlbee/bitlbee
-
-More documentation on the Wiki:
-https://wiki.bitlbee.org/
+http://www.bitlbee.org/
 
 
-A NOTE ON PASSWORD ENCRYPTION
-=============================
+A NOTE ON ENCRYPTION
+====================
 
-BitlBee currently uses salted MD5 and RC4 to store the passwords. This means
-that people who somehow get their hands on your configuration files can't
-easily extract your passwords from them anymore.
+BitlBee stores the accounts and settings (not your contact list though) in
+some sort of encrypted/obfuscated format.
 
-However, once you log into the BitlBee server and send your password, an
-intruder with tcpdump can still read your passwords. This can't really be
-avoided, of course. So if you run a public server, it's most important that you
-don't give root access to people who like to play with tcpdump.
+*** THIS IS NOT A SAFE FORMAT! ***
+
+You should still make sure the rights to the configuration directory and
+files are set so that only root and the BitlBee user can read/write them.
+
+This format is not to prevent malicicous users from running with your
+passwords, but to prevent accidental glimpses of the administrators to cause
+any harm. You have no choice but to trust root though.
+
 
 LEGAL
@@ -165,7 +151,22 @@
 file COPYING for this license.
 
+Unfortunately some parts of the Gaim Jabber plugin (most notably the XML
+code) were licensed under the MPL (Mozilla Public License) version 1.1. We
+could not relicense this code under the GPL. As such it is still licensed
+under the MPL. The parts of the code to which this applies are marked as
+such.
+
+The MPL is provided in the file MPL-1.1.txt. This license is not GPL
+compatible. It is however a free software license.
+
+Another part (the md5 algorithm) is licensed under the Aladdin license.
+This license can be found in the files, to which this applies.
+
+The Yahoo! library used by BitlBee is libyahoo2 <http://libyahoo2.sf.net/>,
+also licensed under the GPL.
+
 
 	BitlBee - An IRC to other chat networks gateway 
-	          <https://www.bitlbee.org/>
-	Copyright (C) 2002-2010  Wilmer van der Gaast <wilmer@gaast.net>
+	          <http://www.bitlbee.org/>
+	Copyright (C) 2002-2004  Wilmer van der Gaast <wilmer@gaast.net>
 	                         and others
Index: doc/TODO
===================================================================
--- doc/TODO	(revision b7d3cc34f68dab7b8f7d0777711317b334fc2219)
+++ doc/TODO	(revision b7d3cc34f68dab7b8f7d0777711317b334fc2219)
@@ -0,0 +1,40 @@
+TODO for BitlBee:
+
+We're trying to keep a better TODO list now. The priorities here are somewhat
+random, maybe. Or at least they change from time to time. The "After 1.0"
+changes are very low-priority, the "Before 1.0" are "highest" priority, the
+others are changes we'll do when we feel like doing them. They're usually not
+as critical as the "Before 1.0" changes, but still a bit more important than
+"After 1.0".
+
+KNOWN BUGS TO FIX BEFORE 1.0:
+- 100% cpu usage bugs.
+  -> They're still there... :-(
+- Check if the IRC send flood protection is reliable now.
+  -> Probably not, at least it still causes troubles on logging in for some
+     people. Maybe the thresholds aren't okay yet. Logins are just floody,
+     nothing we can do about that.
+
+Some time: (mainly features)
+- Rewrite Jabber module - the current one sucks.
+- Test Yahoo! groupchats a bit better, because they still seem to be a bit
+  flakey.
+  -> There are bug reports from time to time, but we can't do much about
+     them, possibly it's more a libyahoo2 problem.
+- Groupchats
+  -> Make them work on other nets than MSN/Yahoo as well.
+- Make usernames case-insensitive. (On case-insensitive filesystems this
+  change isn't necessary. This one is going to suck with backward-compati-
+  bilty...)
+  -> We'll probably combine this with the introduction of a better file
+     format for userdata.
+- Remind the user of unanswered questions after some time.
+- Maybe a way to send global messages. (for server shutdowns, for example)
+- Away-auto-replies.
+- Allow nick changes.
+
+After 1.0: (mainly toys)
+- File transfers -> DCC
+- SSL support? Persistent connections? Things you can do with a bouncer/proxy.
+- Support for buddy groups.
+- What else?
Index: doc/bitlbee.xinetd
===================================================================
--- doc/bitlbee.xinetd	(revision 210d1d9cf4366d9933c02383300175e4b573be61)
+++ doc/bitlbee.xinetd	(revision b7d3cc34f68dab7b8f7d0777711317b334fc2219)
@@ -2,26 +2,11 @@
 ## user, port and/or binary location might be wrong.
 
-## This file assumes you have ircd somewhere in your /etc/services, if things
-## don't work, check that file first.
-service ircd
+service 6667
 {
-	disable = yes
 	socket_type     = stream
 	protocol        = tcp
 	wait            = no
-	
-	user            = bitlbee
-	server          = /usr/sbin/bitlbee
-	server_args     = -I
-	
-	## You might want to limit access to localhost only:
-	bind            = 127.0.0.1
-	
-	## Thanks a lot to friedman@splode.com for telling us about the type
-	## argument, so now this file can be used without having to edit
-	## /etc/services too.
-	type            = UNLISTED
-	port            = 6667
-
-	log_on_failure	+= USERID
+	user            = nobody
+	server          = /usr/local/sbin/bitlbee
+	port		= 6667
 }
Index: doc/user-guide/Makefile
===================================================================
--- doc/user-guide/Makefile	(revision 210d1d9cf4366d9933c02383300175e4b573be61)
+++ doc/user-guide/Makefile	(revision b7d3cc34f68dab7b8f7d0777711317b334fc2219)
@@ -1,14 +1,7 @@
 -include ../../Makefile.settings
-ifdef _SRCDIR_
-_SRCDIR_ := $(_SRCDIR_)doc/user-guide/
-endif
+EXTRAPARANEWLINE = 1
+# EXTRAPARANEWLINE = 0
 
-ifndef PYTHON
-PYTHON = python
-endif 
-
-all: help.txt
-
-user-guide: user-guide.txt user-guide.html # user-guide.pdf user-guide.ps user-guide.rtf
+all: user-guide.txt user-guide.html help.txt # user-guide.pdf user-guide.ps user-guide.rtf
 
 %.tex: %.db.xml
@@ -20,5 +13,5 @@
 
 %.html: %.db.xml
-	xsltproc --param generate.consistent.ids 1 --output $@ http://docbook.sourceforge.net/release/xsl/current/xhtml/docbook.xsl $<
+	xsltproc --output $@ http://docbook.sourceforge.net/release/xsl/current/html/docbook.xsl $<
 
 %.pdf: %.db.xml
@@ -35,6 +28,6 @@
 	xsltproc --xinclude --output $@ docbook.xsl $< 
 
-help.txt: $(_SRCDIR_)help.xml $(_SRCDIR_)commands.xml $(_SRCDIR_)misc.xml $(_SRCDIR_)quickstart.xml $(_SRCDIR_)twitter.xml
-	$(PYTHON) $(_SRCDIR_)genhelp.py $< $@
+help.txt: help.xml help.xsl
+	xsltproc --stringparam extraparanewline "$(EXTRAPARANEWLINE)" --xinclude help.xsl $< | perl -0077 -pe 's/\n\n%/\n%/s; s/_b_/\002/g;' > $@
 
 clean: 
@@ -45,5 +38,5 @@
 	chmod 0755 $(DESTDIR)$(DATADIR)
 	rm -f $(DESTDIR)$(DATADIR)/help.txt # Prevent help function from breaking in running sessions
-	$(INSTALL) -m 0644 $(_SRCDIR_)help.txt $(DESTDIR)$(DATADIR)/help.txt
+	install -m 0644 help.txt $(DESTDIR)$(DATADIR)/help.txt
 
 uninstall:
@@ -51,3 +44,3 @@
 	-rmdir $(DESTDIR)$(DATADIR)
 
-.PHONY: clean install uninstall user-guide
+.PHONY: clean install uninstall
Index: doc/user-guide/docbook.xsl
===================================================================
--- doc/user-guide/docbook.xsl	(revision 210d1d9cf4366d9933c02383300175e4b573be61)
+++ doc/user-guide/docbook.xsl	(revision b7d3cc34f68dab7b8f7d0777711317b334fc2219)
@@ -19,5 +19,5 @@
 
 	<xsl:template match="ircaction">
-		<xsl:text> * </xsl:text><xsl:value-of select="@nick"/><xsl:text> </xsl:text><xsl:value-of select="normalize-space(.)"/><xsl:text>&#10;</xsl:text>
+		<xsl:text> * </xsl:text><xsl:value-of select="@nick"/><xsl:value-of select="normalize-space(.)"/><xsl:text>&#10;</xsl:text>
 	</xsl:template>
 
@@ -83,5 +83,4 @@
 
 	<xsl:template name="cmd">
-		<xsl:param name="prefix"/>
 		<xsl:variable name="thiscmd"><xsl:value-of select="$prefix"/><xsl:value-of select="@name"/></xsl:variable>
 		<xsl:attribute name="id">
Index: doc/user-guide/help.xsl
===================================================================
--- doc/user-guide/help.xsl	(revision 210d1d9cf4366d9933c02383300175e4b573be61)
+++ doc/user-guide/help.xsl	(revision b7d3cc34f68dab7b8f7d0777711317b334fc2219)
@@ -7,5 +7,5 @@
 	version="1.1">
 
-	<xsl:output method="text" encoding="utf-8" standalone="yes"/>
+	<xsl:output method="text" encoding="iso-8859-1" standalone="yes"/>
 	<xsl:strip-space elements="*"/>
 
@@ -31,5 +31,4 @@
 
 	<xsl:template name="subject">
-		<xsl:param name="id"/>
 		<xsl:message><xsl:text>Processing: </xsl:text><xsl:value-of select="$id"/></xsl:message>
 		<xsl:text>?</xsl:text><xsl:value-of select="$id"/><xsl:text>&#10;</xsl:text>
@@ -59,8 +58,5 @@
 			<xsl:text>?set </xsl:text><xsl:value-of select="@name"/><xsl:text>&#10;</xsl:text>
 			<xsl:text>_b_Type:_b_ </xsl:text><xsl:value-of select="@type"/><xsl:text>&#10;</xsl:text>
-			<xsl:text>_b_Scope:_b_ </xsl:text><xsl:value-of select="@scope"/><xsl:text>&#10;</xsl:text>
-			<xsl:if test="default">
-				<xsl:text>_b_Default:_b_ </xsl:text><xsl:value-of select="default"/><xsl:text>&#10;</xsl:text>
-			</xsl:if>
+			<xsl:text>_b_Default:_b_ </xsl:text><xsl:value-of select="default"/><xsl:text>&#10;</xsl:text>
 			<xsl:if test="possible-values">
 				<xsl:text>_b_Possible Values:_b_ </xsl:text><xsl:value-of select="possible-values"/><xsl:text>&#10;</xsl:text>
@@ -73,9 +69,7 @@
 
 	<xsl:template match="command-list">
-		<xsl:text>These are all root commands. See _b_help &lt;command name&gt;_b_ for more details on each command.&#10;&#10;</xsl:text>
 		<xsl:for-each select="../bitlbee-command">
 			<xsl:text> * _b_</xsl:text><xsl:value-of select="@name"/><xsl:text>_b_ - </xsl:text><xsl:value-of select="short-description"/><xsl:text>&#10;</xsl:text>
 		</xsl:for-each>
-		<xsl:text>&#10;Most commands can be shortened. For example instead of _b_account list_b_, try _b_ac l_b_.&#10;</xsl:text>
 		<xsl:text>&#10;</xsl:text>
 	</xsl:template>
@@ -125,5 +119,4 @@
 
 	<xsl:template name="cmd">
-		<xsl:param name="prefix"/>
 		<xsl:variable name="thiscmd"><xsl:value-of select="$prefix"/><xsl:value-of select="@name"/></xsl:variable>
 		<xsl:message><xsl:text>Processing command '</xsl:text><xsl:value-of select="$thiscmd"/><xsl:text>'</xsl:text></xsl:message>
Index: help.c
===================================================================
--- help.c	(revision 210d1d9cf4366d9933c02383300175e4b573be61)
+++ help.c	(revision b7d3cc34f68dab7b8f7d0777711317b334fc2219)
@@ -1,6 +1,6 @@
-/********************************************************************\
+  /********************************************************************\
   * BitlBee -- An IRC to other IM-networks gateway                     *
   *                                                                    *
-  * Copyright 2002-2010 Wilmer van der Gaast and others                *
+  * Copyright 2002-2004 Wilmer van der Gaast and others                *
   \********************************************************************/
 
@@ -20,17 +20,16 @@
   You should have received a copy of the GNU General Public License with
   the Debian GNU/Linux distribution in /usr/share/common-licenses/GPL;
-  if not, write to the Free Software Foundation, Inc., 51 Franklin St.,
-  Fifth Floor, Boston, MA  02110-1301  USA
+  if not, write to the Free Software Foundation, Inc., 59 Temple Place,
+  Suite 330, Boston, MA  02111-1307  USA
 */
 
 #define BITLBEE_CORE
 #include "bitlbee.h"
-#include "help.h"
-#undef read
+#undef read 
 #undef write
 
-#define BUFSIZE 2048
+#define BUFSIZE 1100
 
-help_t *help_init(help_t **help, const char *helpfile)
+help_t *help_init( help_t **help )
 {
 	int i, buflen = 0;
@@ -39,85 +38,70 @@
 	time_t mtime;
 	struct stat stat[1];
-
-	*help = h = g_new0(help_t, 1);
-
-	h->fd = open(helpfile, O_RDONLY);
-
-	if (h->fd == -1) {
-		g_free(h);
-		return(*help = NULL);
+	
+	*help = h = g_new0 ( help_t, 1 );
+	
+	h->fd = open( global.helpfile, O_RDONLY
+#ifdef _WIN32
+				  | O_BINARY
+#endif
+				  );
+	
+	if( h->fd == -1 )
+	{
+		g_free( h );
+		return( *help = NULL );
 	}
-
-	if (fstat(h->fd, stat) != 0) {
-		g_free(h);
-		return(*help = NULL);
+	
+	if( fstat( h->fd, stat ) != 0 )
+	{
+		g_free( h );
+		return( *help = NULL );
 	}
 	mtime = stat->st_mtime;
-
-	s = g_new(char, BUFSIZE + 1);
+	
+	s = g_new (char, BUFSIZE + 1 );
 	s[BUFSIZE] = 0;
-
-	while (((i = read(h->fd, s + buflen, BUFSIZE - buflen)) > 0) ||
-	       (i == 0 && strstr(s, "\n%\n"))) {
+	
+	while( ( ( i = read( h->fd, s + buflen, BUFSIZE - buflen ) ) > 0 ) ||
+	       ( i == 0 && strstr( s, "\n%\n" ) ) )
+	{
 		buflen += i;
-		memset(s + buflen, 0, BUFSIZE - buflen);
-		if (!(t = strstr(s, "\n%\n")) || s[0] != '?') {
+		memset( s + buflen, 0, BUFSIZE - buflen );
+		if( !( t = strstr( s, "\n%\n" ) ) || s[0] != '?' )
+		{
 			/* FIXME: Clean up */
-			help_free(help);
-			g_free(s);
-			return NULL;
+//			help_close( *help );
+			*help = NULL;
+			g_free( s );
+			return( NULL );
 		}
-		i = strchr(s, '\n') - s;
-
-		if (h->title) {
-			h = h->next = g_new0(help_t, 1);
+		i = strchr( s, '\n' ) - s;
+		
+		if( h->string )
+		{
+			h = h->next = g_new0( help_t, 1 );
 		}
-		h->title = g_new(char, i);
-
-		strncpy(h->title, s + 1, i - 1);
-		h->title[i - 1] = 0;
+		h->string = g_new ( char, i );
+		
+		strncpy( h->string, s + 1, i - 1 );
+		h->string[i-1] = 0;
 		h->fd = (*help)->fd;
-		h->offset.file_offset = lseek(h->fd, 0, SEEK_CUR) - buflen + i + 1;
+		h->offset.file_offset = lseek( h->fd, 0, SEEK_CUR ) - buflen + i + 1;
 		h->length = t - s - i - 1;
 		h->mtime = mtime;
-
-		buflen -= (t + 3 - s);
-		t = g_strdup(t + 3);
-		g_free(s);
-		s = g_renew(char, t, BUFSIZE + 1);
+		
+		buflen -= ( t + 3 - s );
+		t = g_strdup( t + 3 );
+		g_free( s );
+		s = g_renew( char, t, BUFSIZE + 1 );
 		s[BUFSIZE] = 0;
 	}
-
-	g_free(s);
-
-	return(*help);
+	
+	g_free( s );
+	
+	return( *help );
 }
 
-void help_free(help_t **help)
-{
-	help_t *h, *oh;
-	int last_fd = -1; /* Weak de-dupe */
-
-	if (help == NULL || *help == NULL) {
-		return;
-	}
-
-	h = *help;
-	while (h) {
-		if (h->fd == -1) {
-			g_free(h->offset.mem_offset);
-		} else if (h->fd != last_fd) {
-			close(h->fd);
-			last_fd = h->fd;
-		}
-		g_free(h->title);
-		h = (oh = h)->next;
-		g_free(oh);
-	}
-
-	*help = NULL;
-}
-
-char *help_get(help_t **help, char *title)
+char *help_get( help_t **help, char *string )
 {
 	time_t mtime;
@@ -125,83 +109,40 @@
 	help_t *h;
 
-	for (h = *help; h; h = h->next) {
-		if (h->title != NULL && g_strcasecmp(h->title, title) == 0) {
-			break;
+	h=*help;	
+
+	while( h )
+	{
+		if( g_strcasecmp( h->string, string ) == 0 ) break;
+		h = h->next;
+	}
+	if( h )
+	{
+		char *s = g_new( char, h->length + 1 );
+		
+		if( fstat( h->fd, stat ) != 0 )
+		{
+			g_free( h );
+			*help=NULL;
+			return( NULL );
 		}
+		mtime = stat->st_mtime;
+		
+		if( mtime > h->mtime ) {
+			return( NULL );
+			return( g_strdup( "Help file changed during this session. Please restart to get help back." ) );
+		}
+		s[h->length] = 0;
+		if( h->fd >= 0 )
+		{
+			lseek( h->fd, h->offset.file_offset, SEEK_SET );
+			read( h->fd, s, h->length );
+		}
+		else
+		{
+			strncpy( s, h->offset.mem_offset, h->length );
+		}
+		return( s );
 	}
-	if (h && h->length > 0) {
-		char *s = g_new(char, h->length + 1);
-
-		s[h->length] = 0;
-		if (h->fd >= 0) {
-			if (fstat(h->fd, stat) != 0) {
-				g_free(s);
-				return NULL;
-			}
-			mtime = stat->st_mtime;
-
-			if (mtime > h->mtime) {
-				g_free(s);
-				return NULL;
-			}
-
-			if (lseek(h->fd, h->offset.file_offset, SEEK_SET) == -1 ||
-			    read(h->fd, s, h->length) != h->length) {
-				g_free(s);
-				return NULL;
-			}
-		} else {
-			strncpy(s, h->offset.mem_offset, h->length);
-		}
-		return s;
-	}
-
-	return NULL;
+	
+	return( NULL );
 }
-
-int help_add_mem(help_t **help, const char *title, const char *content)
-{
-	help_t *h, *l = NULL;
-
-	for (h = *help; h; h = h->next) {
-		if (g_strcasecmp(h->title, title) == 0) {
-			return 0;
-		}
-
-		l = h;
-	}
-
-	if (l) {
-		h = l->next = g_new0(struct help, 1);
-	} else {
-		*help = h = g_new0(struct help, 1);
-	}
-	h->fd = -1;
-	h->title = g_strdup(title);
-	h->length = strlen(content);
-	h->offset.mem_offset = g_strdup(content);
-
-	return 1;
-}
-
-char *help_get_whatsnew(help_t **help, int old)
-{
-	GString *ret = NULL;
-	help_t *h;
-	int v;
-
-	for (h = *help; h; h = h->next) {
-		if (h->title != NULL && strncmp(h->title, "whatsnew", 8) == 0 &&
-		    sscanf(h->title + 8, "%x", &v) == 1 && v > old) {
-			char *s = help_get(&h, h->title);
-			if (ret == NULL) {
-				ret = g_string_new(s);
-			} else {
-				g_string_append_printf(ret, "\n\n%s", s);
-			}
-			g_free(s);
-		}
-	}
-
-	return ret ? g_string_free(ret, FALSE) : NULL;
-}
